#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

typedef unsigned int uint;
typedef unsigned char uchar;

#define GC_BRGI 15
#define GC_BRG 7
#define GC_BR 3
#define GC_R 2
#define GC_B 1
#define PATTERN_BLUE 0
#define PATTERN_RED 1
#define PATTERN_GREEN 2
#define PATTERN_INTEN 3
#define PLANE_BLUE 1
#define PLANE_RED 2
#define TX_BLACK     0x00  /* 0x01 ij   0x01  */
#define TX_BLUE      0x01  /* 0x01 iȂj 0x21  */
#define TX_RED       0x02  /* 0x01 iȂj 0x41  */
#define TX_MAGENTA   0x03  /* 0xe1 ij   0x61  */
#define TX_GREEN     0x04  /* 0x61 ΁ij   0x81  */
#define TX_CYAN      0x05  /* 0x21 ij   0xa1  */
#define TX_YELLOW    0x06  /* 0xc1 ij   0xc1  */
#define TX_WHITE     0x07  /* 0x21 ij   0xe1  */
#define TX_REVERSE   0x08  /* ]                    */
#define TX_UNDERLINE 0x10  /*                     */

void grcg_hline( int x1, int x2, int y );
void grcg_vline( int x, int y1, int y2 );
void grcg_boxfill( int x1, int y1, int x2, int y2 );
void grcg_setcolor( int mode, int color );
void grcg_off(void);
void xor_vline(int x); /* R G B 3v[XORł̏c` */

void settempo(uint bias);
int key_check(void);
int key_check_edit(void);

void usr_excl(void);      /* 90-97 UsrExc   */
void tr_excl(void);          /* 98 Tr.Excl  */
void rol_base(void);         /* dd RolBase  */
void rol_para(void);         /* de RolPara  */
void rol_dev(void);          /* df RolDev#  */
void bank_program(void);     /* e2 BankPrg  */
void midi_channel(void);     /* e6 MIDI CH. */
void ch_pressure(void);      /* ea AFTER C. */
void key_pressure(void);     /* ed AFTER K. */
void loop_end(void);         /* f8    ]     */
void loop_begin(void);       /* f9    [     */
void same_meas(void);        /* fc ======== */
void meas_end(void);         /* fd -------- */

void key_off_18tr(void);     /*LĂSĂnotenote off*/

void set_data(void); /* Cobt@ɃeLXgf[^Zbg */
void next_data(void);  /* Psi߂ */
void prev_data(void);  /* Ps߂ */
void meas_top(void);   /* ߐ擪ɖ߂ */

void gamen_start(void);
int read_file(void);
void init_data(void);

uint tempo = 120;   /* e|(10`120`240) */
uint delta = 10417; /* usP (T=120̎ delta=10.417ms) */
int intc1;
int intc2;          /* 2003 */
uchar *fdata = NULL;

uint  drum_name[128];   /* hK#ƖO|C^̑Ή */

extern uchar  ons[18];         /* Ă鉹̐Bő16 */
extern uchar  r_step[18][16];  /* c蔭Xebv */
extern uchar  r_key[18][16];   /* Ăj */
extern uchar  velgraph[18];    /* Velocity_Otp */

extern int counts[18];
extern uchar *pointb[18];      /* egbÑx[X|Cg */
extern uchar *points[18];      /* egbÑJg|Cg */
extern uchar *pointc;          /* Jg|Cg */
extern int ctr;                /* JggbN */
extern char endfs[18];         /* GhtO */
extern int meass[18];
extern int measc;              /* Jgߔԍ */

extern char  play_bias;           /* SgbNΏۂK# */
extern uchar rhythm_mode[18];     /* Y on..0x80 off..0x00 */
extern uchar tr_ch[18];           /* gbNoCHΉ\ */
extern char  key_bias[18];        /* KEY#+l */
extern char  st_bias[18];         /* STl */
extern uchar tr_mode[18];         /* MODE (0:Play 1:Mute 2:Mix 4:Rec) */
                                  /*      (8:MIDI CH.OFF 16:note֌WOFF) */
extern uchar rol_ex_data[18][11]; /* Roland Exclusive f[^ */

extern uchar *lp_s[18];   /* same measIĖ߂ʒuBOȂs.m.łȂ */
extern uchar *lp_l1[18][5]; /* [v̐擪i[̎j */
extern uchar *lp_l2[18][5]; /* s.m.[ꍇ́As.m.IĖ߂ʒu */
extern int  lp_l3[18][5]; /* [vJE^iOBJEgAbvj */
extern uint lp_l4[18][5]; /* [v擪̏ߔԍ */
extern uint lp_ln[18];    /* [vo^ */

extern uchar rec0, rec1, rec2, rec3;
extern int cur_mode;
char sys_mode = 1;   /* VXe[h       */
                     /* 0..tigbNj*/
                     /* 1..ҏWigbNj*/
                     /* 2..t(S̕\)  */
                     /* 3..CR}h    */
                     /* 4..h̃[hitj */
                     /* 5..gbNZbeBO */
extern int g_count;  /* O[oJEg */

int shift;    /* VtgL[Q̏ */

int kbias = 0; /* Music Key̏̓gbNɎׂ */
uchar kbias_trans[16] = {0,7,2,9,4,11,6,1,0,5,10,3,8,1,6,11};
char *nn = "C C#D D#E F F#G G#A BbB ";
char *MMkey
       = "C G D A E B F#C#C F BbEbAbDbGbCbA E B F#C#G#D#A#A D G C F BbEbAb";

void check_s_jis(void);
void text_putsa( unsigned x, unsigned y, const char *str, unsigned atrb );
void midi_out(int data);
void midi_out_long(char *p, int n);
void dbg_disp(int i);
void dbg_str(char *p);
void display_text(void);
void display_smemo(void);  /* \O\ */
void display_tmemo(void);
void display_graph(void);
void display_kenban(void);
void draw_graph(void);
int get_key(void);
void unget_key(int k);

void text_puts( unsigned x, unsigned y, const char *strp );
void put_note(int x, int y, int num);

void key_off_18tr()     /*LĂSĂnotenote off*/
{
    uint i, j;

    for (i = 0; i < 18; i++) {
        for (j = 0; j < 16; j++) {
            if (r_step[i][j] != 0) {
                midi_out(r_key[i][j] * 0x100 + 0x90 + tr_ch[i]);
            }
        }
    }
}

/*----------------------------------------------*/

uchar nimage[] = {  /* W~cThbg */
                 0x3c, 0x62, 0x42, 0x46, 0x3c,    /* B:  */
                 0x1c, 0x3e, 0x7e, 0x7c, 0x38,    /* R:  */
                 0x50, 0xf8, 0x50, 0xf8, 0x50,    /* G:    */
                 0x00, 0x00, 0x00, 0x00, 0x00};   /* I: gp */

  /* gLAwLA 16x66hbg\ */
int toon[] = {0x00e0,0x01e0,0x01e0,0x03f0,0x0390,0x0710,0x0710,0x0710,
              0x0610,0xffff,0x0630,0x0670,0x02e0,0x03e0,0x03e0,0xffff,
              0x07c0,0x0f80,0x1f80,0x3d80,0x7980,0xffff,0xf3f8,0xe7fc,
              0xeece,0xccc7,0xc863,0xffff,0xe863,0x7666,0x3324,0x19ac,
              0x0e38,0xffff,0x0020,0x0020,0x0f10,0x0f10,0x1f90,0x0f10,
              0x0f10,0x0420,0x03c0,0x0000,0x0000,0xffff,0x0f80,0x31c2,
              0x60e7,0xf072,0xfc70,0xffff,0xfc70,0x7c72,0x1077,0x0072,
              0x00e0,0xffff,0x01c0,0x0380,0x0300,0x0600,0x0c00,0xffff,
              0x7000,0xc000};

extern char *pBits;
extern void set_cursor(int x, int y); /* J[\ړB_ŏ󋵂₷ */
extern void my_sleep(void);
extern void my_bitblt(void);
int vline_x; /* XOR`悷c */
char line_data[81];     /* Hobt@ */
int x_curs = 10; /* ҏW̃J[\XW */
                 /* NOTE:10 K#:16 ST:20 GT:24 VEL:28 */
int y_curs = 4;  /* ܂荪̂Ȃl */

void draw_indicator() /* tɐlωPs̃CWP[^ */
{
                   /*"ChM 1Bk  0Pg 37Pb   PdOFFMd---"*/
    text_putsa(0, 2, "Ch",                             TX_CYAN|TX_REVERSE);
    text_putsa(5, 2, "Bk",                             TX_CYAN|TX_REVERSE);
    text_putsa(10,2, "Pg",                             TX_CYAN|TX_REVERSE);
    text_putsa(15,2, "Pb",                             TX_CYAN|TX_REVERSE);
    text_putsa(20,2, "Pd",                             TX_CYAN|TX_REVERSE);
    text_putsa(25,2, "Md",                             TX_CYAN|TX_REVERSE);
                   /*"Vo100Ep127Pn   Memo"*/
    text_putsa(30,2, "Vo",                             TX_CYAN|TX_REVERSE);
    text_putsa(35,2, "Ep",                             TX_CYAN|TX_REVERSE);
    text_putsa(40,2, "Pn",                             TX_CYAN|TX_REVERSE);
    text_putsa(45,2, "Memo",                           TX_CYAN|TX_REVERSE);
    text_putsa(2, 2, "M 1",                            TX_WHITE);
    text_putsa(7, 2, "  0",                            TX_WHITE);
    text_putsa(12,2, " 37",                            TX_WHITE);
    text_putsa(17,2, "   ",                            TX_WHITE);
    text_putsa(22,2, "OFF",                            TX_WHITE);
    text_putsa(27,2, "---",                            TX_WHITE);
    text_putsa(32,2, "100",                            TX_WHITE);
    text_putsa(37,2, "127",                            TX_WHITE);
    text_putsa(42,2, "   ",                            TX_WHITE);
    text_putsa(49,2, " ",                              TX_YELLOW);
}

uchar *p;
int  meas;      /* ߐ(1`) */
int  step;      /* Xebv(1`) */
int  stv;       /* Xebvl(192Ȃ) ߋ؂Ŏgp */
uchar *meas_st_ad;  /* ߐ擪AhX */

uchar *disp_p;
int disp_step;
int disp_meas;
int disp_meas_prev = -1;
int disp_tr;       /*\gbN(0`17)*/
int disp_tr_prev = -1;
int skip_point = 0;
int ret_tr;   /* t~߂Ƃ߂ꏊ */
char *ret_p;  /* t~߂Ƃ߂ꏊ */
char *home_p; /* EDIT[hŕ\Ă擪s */
int get_number1(int x, int y, int max, int *val, char *fmt, int keta);
int get_number2(int x, int y, int max, int *val, char *fmt, int keta);
int play_stop; /* tꎞ~ptO */

void analyze_key(int k);
void analyze_key(int k)
{
    switch (k) {
      case 'n':   /* n */  /* ] */
        rhythm_mode[disp_tr] = rhythm_mode[disp_tr] ^ 0x80; /*Y 0x80*/
        break;
      case 0x1e:  /*  */
      m1:
        p = disp_p;
        meas = disp_meas;
        if (shift & 1) {
            meas_top();      /* pߐ擪AhXɖ߂ */
            prev_data();
            meas_top();      /* pߐ擪AhXɖ߂ */
        }
        else {
            prev_data();
        }
        disp_p = p;
        disp_meas = meas;
        break;
      case 0x1f:  /*  */
      case 0x0d:  /* Enter */
      m2:
        p = disp_p;
        meas = disp_meas;
        if (shift & 1) {
            while (1) {
                if (p[0] >= 0xfe)
                    break;                     /* gbN */
                next_data();
                if (meas != disp_meas)
                    break;
            }
        }
        else {
            next_data();
        }
        disp_p = p;
        disp_meas = meas;
        break;
      case 0x1c:  /*  */
      case ' ':   /* " " */
        switch (x_curs) {
          case 10: x_curs = 20; break;   /* NOTE -> ST       */
          case 16: x_curs = 20; break;   /* K#   -> ST       */
          case 20: x_curs = 24; break;   /* ST   -> GT       */
          case 24: x_curs = 28; break;   /* GT   -> VEL      */
          case 28: x_curs = 10; goto m2; /* VEL  -> NOTE() */
        }
        break;
      case 0x1d:  /*  */
        switch (x_curs) {
          case 10: x_curs = 28; goto m1; /* NOTE -> VEL() */
          case 16: x_curs = 10; break;   /* K#   -> NOTE    */
          case 20: x_curs = 16; break;   /* ST   -> K#      */
          case 24: x_curs = 20; break;   /* GT   -> ST      */
          case 28: x_curs = 24; break;   /* VEL  -> GT      */
        }
        break;
      case '*':  /* W[Gh */
      case '[':  /* s[ggbv */
      case ']':  /* s[gGh */
      case '\\': /* ZCW[ */
      case '^':  /* L[Zbg */
      case '@':  /* gbN */
      case '/':  /* XyVRg[ */
      case 'R':  /* Rs[ */
      case ':':  /* Xgf[^Rs[ */
      case 'I':  /* CT[g */
      case 0x12: /* INS CT[g */
      case 'K':  /* f[g */
      case 0x0b: /* Ctrl-K f[gPXebv */
      case 'Y':  /* y[Xg */
      case 'H':  /* C[X */
      case 'Q':  /* STNH^CY */
      case 'T':  /* gX|[Y */
      case 'V':  /* xVeBVtg */
      case 'X':  /* GNXph/RvX */
      case 'Z':  /* ZbeBO */
      case 'L':  /* [hp[gf[^ */
      case 'S':  /* Z[up[gf[^ */
      case 'M':  /* W[vC */
      case 'J':  /* gbNvC */
      case 'P':  /* |CgvC */
      case 'U':  /* AhD */
      case 0x09: /* Tab ^b`R[h */
      case 'N':  /* YgbNGfBbg */
      case 'W':  /* fBXvCXCb` */
      case '=':  /* GfBbg[h */
      case 0xa2: /* F1-F10/shift ^b`ST/GT */
      case 0x19: /* PageUp Ctrl-Y o[Abv */
      case 0x1a: /* PageDowno[_E */
      case 0x01: /* Ctrl-A End wv */
      case '?':  /* ? wv */
      case 0x1b: /* Esc GfBbgI */
      case 0x0e: /* Ctrl-N lNXgW[ */
      case 0x02: /* Ctrl-B obNW[ */
      case 0x14: /* Ctrl-T gbvW[ */
      case 0x03: /* Ctrl-C T[`XyVRg[ */
      case '.':  /* tH[hPOC */
      case ',':  /* obNPOC */
      case 0x0c: /* Home Zbg^O */
      case ';':  /* STAGT̂PO{̓[h */
      case 0x17: /* Shift + Home ^OWv */
      case '|':  /* gbNGNXN[Vuf[^ */
      case '>':  /* KeyScan */
      case '}':  /* MIDI IN EXCLUSIVE INPUT */
      /* Shift + L[ NCbNgbN`FW */
      /* A B C D E F G NOTE */
      /* (@\蓖ĂȂ) O ~ + - ` { < _ */
        break;
    }
    if (k >= '0' && k <= '9') {
        int val = 0, i;

        unget_key(k);
        if (x_curs == 10) x_curs = 16; /* NOTE -> K# Ɉړ */
        i = get_number2(x_curs - 2, y_curs, 999, &val, "%3d", 3);
        if (i == 1) {
            if (x_curs == 16 && p[0] > 127) goto m3; /* łȂ */
            if (val > 255) val = 255;
            if (x_curs != 20 && val > 127) val = 127;
            /* f[^ */
            switch (x_curs) {
              case 16: p[0] = val; break; /* K#   */
              case 20: p[1] = val; break; /* ST   */
              case 24: p[2] = val; break; /* GT   */
              case 28: p[3] = val; break; /* VEL  */
            }
            disp_tr_prev = -1; /* ĕ` */
        }
      m3:
	;
    }
}

int get_number2(int x, int y, int max, int *val, char *fmt, int keta)
{
    int n, k, f, ret;

    n = *val;
    f = 0;  /* OlptO */
    sprintf(line_data, fmt, n);
    text_putsa(x, y, line_data, TX_WHITE);
    set_cursor(x + keta - 1, y);
    my_bitblt();
    while (1) {
        my_sleep();
        k = get_key();
        if (k == 0) {
            continue;
        }
        else if (k >= '0' && k <= '9') {
            if (f == 0) {
                f = 1;
                n = k - '0';
            }
            else {
                n = n * 10 + k - '0';
                if (n > max) n = n % (max + 1);
            }
        }
        else if (k == 0x07) { /* Del */
            n = n / 10;
        }
        else if (k >= 0x1c && k <= 0x1f || k == 0x0d || k == ' ') {
                              /* Enter" " */
            *val = n;         /* ̕ϐɒln */
            ret = 1;          /* Ԃl͗L */
            break;
        }
        else if (k == 0x1b) { /* Esc */
            ret = 1;          /* Ԃl͖ */
            break;
        }
        else {
            ret = 1;          /* Ԃl͖ */
            break;            /* zÕL[͂̏ꍇ */
        }
        sprintf(line_data, fmt, n);
        text_putsa(x, y, line_data, TX_WHITE);
        set_cursor(x + keta - 1, y);
        my_bitblt();
    }
    set_cursor(-1, -1);
    unget_key(k);
    return(ret);
}

void display_text()
{
    int  i, j, c, meas_bak, step_bak;
    uchar *p_cur, *q;
    int  lines = 20;

    if (disp_tr_prev != disp_tr) {
        /* gbN\ */
        p = pointb[disp_tr] + 0x0008;
        for (i = 0; i < 30; i++)
            line_data[i] = *p++;
        line_data[i] = 0;
        check_s_jis();
        text_putsa(0, 1, line_data, TX_YELLOW);

        /* gbNԍ\ */
        sprintf(line_data, "%2d", disp_tr + 1);
        text_putsa(4, 2, line_data, TX_WHITE);

        /* FREEUSED\ */
        p = pointb[disp_tr] + 0x0000;
        i = (p[0] + p[1]*256 - 48) / 4;
        sprintf(line_data, "%6d", i);
        text_putsa(17, 0, line_data, TX_CYAN|TX_REVERSE);
        i = 16371 - i;
        sprintf(line_data, "%6d", i);
        text_putsa( 5, 0, line_data, TX_CYAN|TX_REVERSE);
    }

    if (sys_mode == 0) { /* t */
        p = lp_s[disp_tr];
        if (p == 0) {              /* same measłȂ */
            p = points[disp_tr];   /* tʒu */
            if (!endfs[disp_tr])
              prev_data();  /* Ps߂(p̂) */
        }
        disp_p = p;
        disp_meas = meass[disp_tr]; /* J[\ʒȕߔԍ */
    }
    else { /* EDIT[h */
    }
    meas = disp_meas;
    p = disp_p;

    if (sys_mode == 0) { /* t */
        p_cur = p;
        for (i = 0; i < lines/2; i++)  /* 10sOɖ߂ */
          prev_data();

        q = p;
        meas_top();      /* pߐ擪AhXɖ߂ */
        while (p < q)    /* ʂɉf镔܂Ői߂ */
          next_data();
    }
    else { /* EDIT[h */
        p_cur = p;
        if (p >= home_p) {
            for (i = 0; i < 20; i++) { /* 20sOɖ߂Ēׂ */
                if (p == home_p) break;
                prev_data();
            }
            if (i == 20) {
                meas = disp_meas;
                p = p_cur;
                for (i = 0; i < lines/2; i++)  /* 10sOɖ߂ */
                  prev_data();
                home_p = p;
            }
        }
        else {
            for (i = 0; i < lines/2; i++)  /* 10sOɖ߂ */
              prev_data();
            home_p = p;
        }
        q = p;
        meas_top();      /* pߐ擪AhXɖ߂ */
        while (p < q)    /* ʂɉf镔܂Ői߂ */
          next_data();
        p = home_p;
    }

    step_bak = -1;   /*  */
    meas_bak = -1;   /*  */

    for (i = 0; i < lines; i++) {  /* 20s */
        set_data();
        if (p[0] == 0xfe)
            goto m1;                               /* ߔԍ͕tȂ */
        if (meas != meas_bak || (sys_mode && p == p_cur))  /* ߔԍ */
            sprintf(&line_data[0], "%4d", meas);
        else
            sprintf(&line_data[0], "    ");
        if (step != step_bak || meas != meas_bak)  /* Xebvԍ */
            sprintf(&line_data[4], " %4d", step);
        else
            sprintf(&line_data[4], "     ");
        meas_bak = meas;
        step_bak = step;
        line_data[9] = ':';

        if (p == p_cur) {
            if (sys_mode == 1) { /* EDIT[h */
                text_putsa(0, i+4, line_data, TX_WHITE|TX_UNDERLINE);
                set_cursor(x_curs, i+4); /* J[\ړB_ŏ󋵂₷ */
                y_curs = i+4;
            }
            else { /* t */
                text_putsa(0, i+4, line_data, TX_WHITE|TX_REVERSE);
                set_cursor(-1, -1);
            }
            disp_step = step;
        }
        else {
m1:         text_putsa(0, i+4, line_data, TX_CYAN);
        }
        next_data();
    }
}

void set_data() /* Cobt@ɃeLXgf[^Zbg */
{
    int  k, s, g, v, i, d;
    char stp[4];
    char *cn;  /* control name */

    k = p[0];
    s = p[1];
    g = p[2];
    v = p[3];
    if (s == 0)
        sprintf(stp, "   ");
    else
        sprintf(stp, "%3d", s);
    if (k <= 0x7f) {
        if (g ==0 || v == 0) {
            sprintf(&line_data[10], "    ");
        }
        else {
            d = drum_name[k];
            if (d && (rhythm_mode[disp_tr] & 0x80)) { /* Y on..0x80 */
                for (i = 0; i < 7; i++) {
                    line_data[10 + i] = fdata[d + i];
                }
                if (v == 127)
                    d = 9;
                else
                    d = (v + 13) / 14;
                sprintf(&line_data[17], " %3s %3d ..%1d ", stp, g, d);
                return;
            }
            else {
                i = k % 12 * 2;
                line_data[10] = nn[i+0];
                line_data[11] = nn[i+1];
                i = k / 12 - 1;
                if (i < 0) {
                    line_data[12] = '-';
                    line_data[13] = '1';
                }
                else {
                    line_data[12] = '0' + i;
                    line_data[13] = ' ';
                }
            }
        }
        sprintf(&line_data[14], "%3d %3s %3d %3d ", k, stp, g, v);
        return;
    }
    if (k >= 0x90 && k <= 0x97) {  /* USER EX1`8 */
        sprintf(&line_data[10], "UsrExc%1d %3s %3d %3d ", k&7+1, stp, g, v);
        return;
    }
    switch (k) {
      case 0x98:  /*gbNGNXN[Vu*/
        sprintf(&line_data[10], "Tr.Excl %3s %3d %3d ", stp, g, v);
        return;
      case 0xdd:  /* Rol Base */
        sprintf(&line_data[10], "RolBase %3s %3d %3d ", stp, g, v);
        return;
      case 0xde:  /* Rol Para */
        sprintf(&line_data[10], "RolPara %3s %3d %3d ", stp, g, v);
        return;
      case 0xdf:  /* Rol Dev */
        sprintf(&line_data[10], "RolDev# %3s %3d %3d ", stp, g, v);
        return;
      case 0xe2:  /* Bank & Prog */
        sprintf(&line_data[10], "BankPrg %3s %3d %3d ", stp, g, v);
        return;
      case 0xe5:  /* Key Scan */
        sprintf(&line_data[10], "KeyScan %3s %3d     ", stp, g);
        return;
      case 0xe6:  /* MIDI Ch change */
        sprintf(&line_data[10], "MIDI CH.%3s ", stp);
        if (g == 0 || g > 32) {
            sprintf(&line_data[22], "OFF     ");
            return;
        }
        if (g < 17)
            line_data[22] = 'M';
        else {
            line_data[22] = 'R';
            g -= 16;
        }
        sprintf(&line_data[23], "%2d     ", g);
        return;
      case 0xe7:  /*e|`FW*/
        sprintf(&line_data[10], "TEMPO   %3s %3d %3d ", stp, g, v);
        return;
      case 0xea:  /* Ch Pressure */
        sprintf(&line_data[10], "AFTER C.%3s %3d     ", stp, g);
        return;
      case 0xeb:  /*Rg[`FW*/
        switch (g) {
          case 0x00:
          case 0x20: cn = "PG.BANK"; break;
          case 0x01: cn = "MODULAT"; break;
          case 0x05: cn = "PORTA T"; break;
          case 0x06: cn = "DATA(M)"; break;
          case 0x07: cn = "VOLUME "; break;
          case 0x0a: cn = "PANPOT "; break;
          case 0x0b: cn = "EXPRESS"; break;
          case 0x26: cn = "DATA(L)"; break;
          case 0x40: cn = "PEDAL  "; break;
          case 0x41: cn = "PORTAM "; break;
          case 0x42: cn = "SOSTEN "; break;
          case 0x43: cn = "SOFT   "; break;
          case 0x54: cn = "LEGART "; break;
          case 0x5b: cn = "REVERB "; break;
          case 0x5d: cn = "CHORUS "; break;
          case 0x62: cn = "NRPN(L)"; break;
          case 0x63: cn = "NRPN(M)"; break;
          case 0x64: cn = "RPN (L)"; break;
          case 0x65: cn = "RPN (M)"; break;
          case 0x78: cn = "AlSndOf"; break;
          case 0x79: cn = "RstAlCt"; break;
          case 0x7a: cn = "LoclCnt"; break;
          case 0x7b: cn = "AlNtOff"; break;
          default:   cn = "CONTROL"; break;
        }
        sprintf(&line_data[10], "%s", cn);
        sprintf(&line_data[17], " %3s %3d %3d ", stp, g, v);
        return;
      case 0xec:  /*vO`FW*/
        sprintf(&line_data[10], "PROGRAM %3s %3d     ", stp, g);
        return;
      case 0xed:  /* Key Pressure */
        sprintf(&line_data[10], "AFTER K.%3s %3d %3d ", stp, g, v);
        return;
      case 0xee:  /*sb`xh*/
        v = (v - 64) * 128 + g;
        if (v >= 0)
            sprintf(&line_data[10], "PITCH   %3s    %4d ", stp, v);
        else
            sprintf(&line_data[10], "PITCH   %3s   -%4d ", stp, -v);
        return;
      case 0xf5:  /* Music Key */
        sprintf(&line_data[10], "Music Key ");
        s = s & 0x001f;
        line_data[20] = MMkey[s*2];
        line_data[21] = MMkey[s*2+1];
        if (s < 16)
            sprintf(&line_data[22], "MAJOR   ");
        else
            sprintf(&line_data[22], "minor   ");
        return;
      case 0xf6:  /*Rg*/
        for (i = 0; i < 10; i++) {
            line_data[10 + i*2] = p[i*4 + 2];
            line_data[11 + i*2] = p[i*4 + 3];
        }
        line_data[30] = 0;
        check_s_jis();
        return;
      case 0xf8:  /* Loop End */
        sprintf(&line_data[10], "     ]  %3d         ", s);
        return;
      case 0xf9:  /* Loop Begin */
        sprintf(&line_data[10], "     [              ");
        return;
      case 0xfc:  /* Same Measure */
        sprintf(&line_data[10], "========%3d ======= ", s+((g&3)<<8)+1);
        return;
      case 0xfd:  /* Measure End */
        sprintf(&line_data[10], "------ %4d ------- ", stv);
        return;
      case 0xfe:  /*gbNGh*/
        for (i = 0; i < 30; i++) {
            line_data[i] = ' ';
        }
        line_data[i] = 0;
        return;
      default:
        sprintf(&line_data[10], "*** UNKNOWN ******* ");
    }
}

void next_data()       /* Psi߂(p) meas:ߐ step:Xebvf */
{
    uchar k, k2, s;

    k = p[0];
    s = p[1];
    if (k >= 0xfe)
        return;                     /* gbN */
    p += 4;
    while ((k2 = p[0]) == 0xf7)     /* ZJhCxg΂ */
        p += 4;
    if (k >= 0xfc || k2 == 0xfc) {  /* same measure,(ߐ)̂Ƃ */
        meas_st_ad = p;        /* ߐ擪AhX */
        step = 1;              /* Xebv */
        stv = 0;
        meas++;                /* ߑ */
        return;
    }
    if (k >= 0xf0) {           /* f5:key change,f6:comment,f8:f9:loop */
        if (k != 0xf8)         /* f8:loop end */
            return;
        if (k2 >= 0xfc)        /* same measure,(ߐ)̂Ƃ */
            return;
        if (k2 == 0xf8)        /* f8:loop end */
            return;
        step++;                /* Xebv */
        return;
    }
    if (k2 == 0xfc)            /* same measure */
        return;
    stv += s;
    if (k2 == 0xf8)            /* f8:loop end */
        return;
    if (s == 0)                /* Xebvl0ȂOf[^ƂĂ */
        return;
    step++;                    /* Xebv */
    return;
}

void prev_data_new()               /* Ps߂(p̂) */
{
    uchar *q;

    while (1) {
        if (p - pointb[disp_tr] == 0x2c)
          break;               /* gbN擪 */
        p -= 4;
        if (p[0] == 0xf7)      /* RgAGNXNVuȂǂ̌㔼H */
          continue;
        if (p[1] != 0) {
            step--;
            stv -= p[1];
        }
        if (p[0] >= 0xfc) {    /* same meas⏬ߐ(ꉞTrackEnd) */
            meas--;
            q = p;
            meas_top();        /* pߐ擪AhXɖ߂ */
            while (p < q)      /* ʂɉf镔܂Ői߂ */
              next_data();
        }
        break;
    }
}

void prev_data()               /* Ps߂(p̂) */
{
    while (1) {
        if (p - pointb[disp_tr] == 0x2c)
          break;               /* gbN擪 */
        p -= 4;
        if (p[0] == 0xf7)      /* RgAGNXNVuȂǂ̌㔼H */
          continue;
        if (p[0] >= 0xfc)      /* same meas⏬ߐ(ꉞTrackEnd) */
          meas--;
        break;
    }
}

void meas_top()                /* pߐ擪AhXɖ߂ */
{
    uchar *q;

    step = 1;                  /* Xebv͕K1 */
    stv = 0;
    if (p[0] == 0xfc)          /* same measure? */
        return;
    while (1) {
        if (p - pointb[disp_tr] == 0x2c)
            break;             /* gbN擪 */
        if (p[-4] >= 0xfc)
            break;
        p -= 4;                /* same measure,ߐ,gbNłȂƂ*/
    }
    return;
}

int key_check()
{
    int  k;

    k = get_key();
    shift = k >> 8;
    k = k & 0xff;
    if (k >= '1' && k <= '8') {
        if (shift & 1)
            disp_tr = k - '0' +10 - 1;
        else
            disp_tr = k - '0' - 1;
        disp_tr_prev = -1;
    }
    else if (k >= 'A' && k <= 'Z') {
        k = k - 'A' + 'a';          /* 啶 */
    }
    switch (k) {
      case '9': disp_tr =  9 - 1; disp_tr_prev = -1; break;
      case '0': disp_tr = 10 - 1; disp_tr_prev = -1; break;
      case '!': disp_tr = 11 - 1; disp_tr_prev = -1; break;
      case '"': disp_tr = 12 - 1; disp_tr_prev = -1; break;
      case '#': disp_tr = 13 - 1; disp_tr_prev = -1; break;
      case '$': disp_tr = 14 - 1; disp_tr_prev = -1; break;
      case '%': disp_tr = 15 - 1; disp_tr_prev = -1; break;
      case '&': disp_tr = 16 - 1; disp_tr_prev = -1; break;
      case '\'':disp_tr = 17 - 1; disp_tr_prev = -1; break;
      case '(': disp_tr = 18 - 1; disp_tr_prev = -1; break;
    }
    return(k);
}

int key_check_edit()
{
    int  k;

    k = get_key();
    shift = k >> 8;
    k = k & 0xff;
    if (k >= 'A' && k <= 'Z') {
        k = k - 'A' + 'a';          /* 啶 */
    }
    switch (k) {
      case '!': disp_tr = 1 - 1; break;
      case '"': disp_tr = 2 - 1; break;
      case '#': disp_tr = 3 - 1; break;
      case '$': disp_tr = 4 - 1; break;
      case '%': disp_tr = 5 - 1; break;
      case '&': disp_tr = 6 - 1; break;
      case '\'':disp_tr = 7 - 1; break;
      case '(': disp_tr = 8 - 1; break;
      case ')': disp_tr = 9 - 1; break;
    }
    return(k);
}

void display_graph()
{
    int  i, cur_meas;
    uchar *p_cur;
    int  cur_stv;   /* ĉXebvhbgʒu */

    if (sys_mode == 0) {
        p = lp_s[disp_tr];
        if (p == 0) {              /* same measłȂ */
            p = points[disp_tr];   /* tʒu */
            if (!endfs[disp_tr])
              prev_data();  /* Ps߂(p̂) */
        }
        cur_meas = meass[disp_tr];  /* J[\ʒȕߔԍ */
    }
    else {
        p = disp_p;
        cur_meas = disp_meas;
    }
    p_cur = p;

    meas_top();      /* pߐ擪AhXɖ߂ */
    while (p < p_cur)    /* Jg܂Ői߂ */
        next_data();
    cur_stv = stv;

    if (disp_meas_prev != cur_meas || disp_tr_prev != disp_tr) {
        disp_meas_prev = cur_meas;
        if (vline_x) {
            xor_vline(vline_x);          /* O߂ł̏c */
            vline_x = 0;
        }
        grcg_setcolor(GC_BR, 0);  /*GRCG̃[hѐFݒ*/
        grcg_boxfill(240, 64, 639, 382); /* Graphf[^NA */
        grcg_off();

        draw_graph();                    /* ͈͂Graphf[^` */

        i = (12 - kbias) % 12 * 2;
        line_data[0] = nn[i+0];
        line_data[1] = nn[i+1];
        line_data[2] = 0;
        text_putsa(32, 6, line_data, TX_WHITE); /* ̕\ */
    }
    if (vline_x != 321 + cur_stv) {
        if (vline_x)
          xor_vline(vline_x);            /* c */
        vline_x = 321 + cur_stv;
        if (vline_x > 630)
          vline_x = 630;
        xor_vline(vline_x);              /* c */

        sprintf(&line_data[0], "%3d", cur_stv);
        text_putsa(26, 2, line_data, TX_WHITE);
    }
}

void draw_graph()
{
    int ang0, ang1, ang2, ang3;
    int  st, stx = 321;
    uchar l, h;
    int   kx;
    int   xt = 0, yt;
    int   xm = 0, ym;
    int   xv = 0, yv;
    int   xe = 0, ye;
    int   xp = 0, yp;

    meas_top();      /* pߐ擪AhXɖ߂ */
    while (1) {
        ang0 = p[0];
        ang1 = p[1];
        ang2 = p[2];
        ang3 = p[3];

        if (ang0 < 0xf0)
            st = ang1;
        else
            st = 0;

        if (ang0 < 0x80 && ang2 && ang3) { /*  */
            grcg_setcolor(GC_B, 1); /*GRCG̃[hѐFݒ*/
            grcg_vline(stx, 381-ang3, 381);
            grcg_hline(stx, stx+ang2, 381-ang3);
            grcg_vline(stx+ang2, 381-ang3, 381);
            grcg_off();
            kx = ang0;
            if (kx <  17) kx =  17;
            if (kx > 106) kx = 106;
            l = kx % 12;
            h = kx / 12;
            if (l > 4) l++;
            kx = l / 2;
            kx = 253 - h*21 - kx*3;
            put_note(stx-3, kx, 1);
        }
        else {
            switch (ang0) {
              case 0xe7:                    /*e|`FW*/
                /*graduation͖*/
                if (xt) {
                    grcg_setcolor(GC_R, 2);
                    grcg_hline(xt, stx, yt);
                    grcg_vline(stx, yt, 381-ang2);
                    grcg_off();
                }
                xt = stx;
                yt = 381-ang2;
                break;
              case 0xeb:                    /*Rg[`FW*/
                if (ang2 ==  1) { /* MODULAT */
                    if (xm) {
                        grcg_setcolor(GC_BR, 3);
                        grcg_hline(xm, stx, ym);
                        grcg_vline(stx, ym, 381-ang3);
                        grcg_off();
                    }
                    xm = stx;
                    ym = 381-ang3;
                    break;
                }
                if (ang2 ==  7) { /* VOLUME  */
                    if (xv) {
                        grcg_setcolor(GC_R, 2);
                        grcg_hline(xv, stx, yv);
                        grcg_vline(stx, yv, 381-ang3);
                        grcg_off();
                    }
                    xv = stx;
                    yv = 381-ang3;
                    break;
                }
                if (ang2 == 11) { /* EXPRESS */
                    if (xe) {
                        grcg_setcolor(GC_BR, 3);
                        grcg_hline(xe, stx, ye);
                        grcg_vline(stx, ye, 381-ang3);
                        grcg_off();
                    }
                    xe = stx;
                    ye = 381-ang3;
                    break;
                }
                break;
              case 0xee:                    /*sb`xh*/
                if (xp) {
                    grcg_setcolor(GC_R, 2);
                    grcg_hline(xp, stx, yp);
                    grcg_vline(stx, yp, 381-ang3);
                    grcg_off();
                }
                xp = stx;
                yp = 381-ang3;
                break;
              case 0xf8:                    /* Loop End */
                break;
              case 0xf9:                    /* Loop Begin */
                break;
              case 0xfc:                    /* Same Measure */
              case 0xfd:                    /* Measure End */
                grcg_setcolor(GC_B, 1); /*GRCG̃[hѐFݒ*/
                grcg_vline(stx, 121, 179);
                grcg_vline(stx, 254, 381);
                grcg_off();
                st = 10;                    /* ̏߂܂10dot󂯂 */
                break;
              case 0xfe:                    /*gbNGh*/
                goto m1;
            }
        }
        p += 4;
        stx += st;
        if (stx > 632) break;
    }
  m1:
    /* ep[^ɂA`ĂʉE[܂ŐL΂ */
    if (xt) {grcg_setcolor(GC_R,  2); grcg_hline(xt, 638, yt);}
    if (xm) {grcg_setcolor(GC_BR, 3); grcg_hline(xm, 638, ym);}
    if (xv) {grcg_setcolor(GC_R,  2); grcg_hline(xv, 638, yv);}
    if (xe) {grcg_setcolor(GC_BR, 3); grcg_hline(xe, 638, ye);}
    if (xp) {grcg_setcolor(GC_R,  2); grcg_hline(xp, 638, yp);}
    grcg_off();
}

void trans_to_p(void);
void trans_to_p()   /* trύXɔmeasstepɂpւ̒Ǐ]ϊ */
{
    /* ϊtrp͖AmeasstepgBϊtrp߂ */
    /* ň̏ꍇ͖16K̃[vƂȂ */
    p = pointb[disp_tr] + 0x002c;      /* gbN̊Jnʒu */
    meas = 1;
    step = 1;
    while (1) {
        if (meas == disp_meas && step == disp_step) break;
        if (meas > disp_meas) {
            disp_meas = meas;
            disp_step = 1;
            break;
        }
        if (p[0] >= 0xfe) {            /* gbN */
            disp_meas = meas;
            disp_step = 1;
            break;
        }
        next_data();
    }
    disp_p = p;
}

void trans_to_meas(void);
void trans_to_meas()   /* trύXɔpɂmeasstepւ̒Ǐ]ϊ */
{
    /* ϊtrmeasstep͖Apg */
    /* ň̏ꍇ͖16K̃[vƂȂ */
    p = pointb[disp_tr] + 0x002c;      /* gbN̊Jnʒu */
    meas = 1;
    step = 1;
    while (1) {
        if (disp_p == p) {
            disp_meas = meas;
            disp_step = step;
            break;
        }
        if (p[0] >= 0xfe) {            /* gbN */
            disp_meas = meas;
            disp_step = 1;
            break;
        }
        next_data();
    }
}

void kenban(void);
void kenban()
{
    int kby = 19, i;
    void draw_key_on(char k);
    void draw_key_off(char k);

    /* Ղ */
    grcg_setcolor(GC_BRG, 4); /*GRCG̃[hѐFݒ*/
    grcg_hline(242, 639, 17);             /* g */
    grcg_vline(242, 17,  48);             /* g */
    grcg_vline(639, 17,  48);             /* g */

    grcg_boxfill(254-2, kby, 254-2+10*7*5+10*3-1, kby+13*2);
    grcg_setcolor(GC_BRG, 0); /*GRCG̃[hѐFݒ*/
    for (i = 5; i <= 5*7*5+5*3; i += 5) {
        grcg_vline(253-2+i*2, kby, kby+13*2);
        if (i%(5*7) != 0 && i%(5*7) != 5*3)
            grcg_boxfill(250-2+i*2,kby, 256-2+i*2,kby+8*2);
    }
    grcg_boxfill(219 + 5*35,kby+26, 223 + 5*35,kby+26);  /* C4̐؂茇 */
#if 0
    for (i = 36; i < 101; i++) draw_key_on(i);
    draw_key_off(61);
#endif
}

void gamen_start()
{
    int  i, j, c;
    char *p;

    memset(pBits, 0, 640*400); /* ʃNA */

    if (sys_mode == 0 || sys_mode == 1) {
        kenban();
        grcg_setcolor(GC_BRGI, 4); /*GRCG̃[hѐFݒ*/
        grcg_hline(242, 639, 48);             /* g */
        grcg_hline(242, 639, 382);            /* g */
        grcg_vline(242, 48, 382);             /* g */
        grcg_vline(639, 48, 382);             /* g */

        grcg_hline(242, 639, 253);

        for (j = 0; j < 66; j++) {            /* gLAwL` */
            for (i = 0; i < 16; i++) {
                if (toon[j] & 1 << (15-i))
                  pBits[640*(399-(111+j))+244+i] |= 4;
            }
        }

        for (j = 78; j <= 102; j=j+6) {
            for (i = 303; i <= 635; i=i+4) {
                pBits[640*(399-j)+i+0] |= 4;  /* ܐ̓_ */
                pBits[640*(399-j)+i+1] |= 4;  /* ܐ̓_ */
            }
        }
        for (j = 198; j <= 222; j=j+6) {
            for (i = 303; i <= 635; i=i+4) {
                pBits[640*(399-j)+i+0] |= 4;  /* ܐ艺̓_ */
                pBits[640*(399-j)+i+1] |= 4;  /* ܐ艺̓_ */
            }
        }
        for (i = 244; i <= 638; i=i+2) {
            pBits[640*(399-317)+i] |= 4;      /* xVeB̒S̓_ */
        }

        for (i = 120; i <= 144; i += 6)
          grcg_hline(242, 639, i);          /* ܐ̌ܖ{̐(i) */
        for (i = 156; i <= 180; i += 6)
          grcg_hline(242, 639, i);          /* ܐ̌ܖ{̐(i) */
        for (i = 321; i <= 561; i += 12)    /* ڐ */
          if ((i-321)%48)
            grcg_vline(i, 250, 253);        /* 4hbgc */
          else
            grcg_vline(i, 247, 253);        /* 7hbgc */
        grcg_off();
        vline_x = 0;                      /* XOR`悷c */
    }

    if (sys_mode == 2) {
        text_putsa(35, 3, "[CLR]   PAUSE     [HOME] JUMP TO EDITOR", TX_WHITE);
        text_putsa(35, 4, "[=]     MUTE      [+]/[-] TEMPO UP/DOWN", TX_WHITE);
        text_putsa(35, 5, "[SPACE] PLAY MONITOR"                   , TX_WHITE);
        text_putsa(35, 6, "[1]-[9],[SHIFT]+[0]-[8] TRACK MONITOR"  , TX_WHITE);
        text_putsa(35, 7, "[ROLL UP]/[ROLL DOWN]   VALUE UP/DOWN"  , TX_WHITE);

        text_putsa(0, 9, "TRACK  :  1   2   3   4   5   6   7   8   9  10",
                   TX_WHITE|TX_REVERSE);
        text_putsa(47, 9, "  11  12  13  14  15  16  17  18 ",
                   TX_WHITE|TX_REVERSE);
        text_putsa(0, 10, "MEASURE:", TX_CYAN|TX_REVERSE);
        text_putsa(0, 11, "STEP   :", TX_CYAN|TX_REVERSE);
        text_putsa(0, 12, "M 0 R 0:", TX_CYAN|TX_REVERSE);
        text_putsa(0, 13, "CHANNEL:", TX_CYAN|TX_REVERSE);
        text_putsa(0, 14, "PG.BANK:", TX_CYAN|TX_REVERSE);
        text_putsa(0, 15, "PROGRAM:", TX_CYAN|TX_REVERSE);
        text_putsa(0, 16, "BENDER :", TX_CYAN|TX_REVERSE);
        text_putsa(0, 17, "PEDAL  :", TX_CYAN|TX_REVERSE);
        text_putsa(0, 18, "MODULAT:", TX_CYAN|TX_REVERSE);
        text_putsa(0, 19, "VOLUME :", TX_CYAN|TX_REVERSE);
        text_putsa(0, 20, "EXPRESS:", TX_CYAN|TX_REVERSE);
        text_putsa(0, 21, "PANPOT :", TX_CYAN|TX_REVERSE);
        text_putsa(0, 22, "        ", TX_CYAN|TX_REVERSE);
        text_putsa(0, 23, "        ", TX_CYAN|TX_REVERSE);
        text_putsa(1, 12, " 0", TX_CYAN);
        text_putsa(5, 12, " 0", TX_CYAN);

        grcg_setcolor(GC_BRGI, 8+5);
        for (i = 1; i <= 18; i++)
          grcg_vline(i*32+8*8-1, 10*16, 24*16);
        grcg_hline(0, 80*8-1, 24*16);
        grcg_off();

        for (j = 10; j <= 21; j++)
          for (i = 0; i < 18; i++)
            text_putsa(i*4+8, j, "---", TX_WHITE);
    }

    if (sys_mode == 2 || sys_mode == 3) {
        text_putsa(0,3, "              ", TX_REVERSE|TX_YELLOW);
        text_putsa(0,4, "TEMPO    :",     TX_REVERSE|TX_CYAN);
        text_putsa(0,5, "PLAY BIAS:",     TX_REVERSE|TX_CYAN);
        text_putsa(0,6, "KEY  :",         TX_REVERSE|TX_CYAN);
        text_putsa(0,7, "BEAT    :",      TX_REVERSE|TX_CYAN);

        text_putsa(14,3, " ",               TX_WHITE);
        text_putsa(15,3, "               ", TX_REVERSE|TX_BLUE);
        text_putsa(15,4, "MIDI THRU:",      TX_REVERSE|TX_CYAN);
        text_putsa(15,5, "SYNC MODE:",      TX_REVERSE|TX_CYAN);
        text_putsa(15,6, "REC INPUT:",      TX_REVERSE|TX_CYAN);

        text_putsa(10,4, "120 ",     TX_WHITE);
        text_putsa(10,5, "  0 ",     TX_WHITE);
        text_putsa( 6,6, "C MAJOR ", TX_WHITE);
        text_putsa( 9,7, " 4/4 ",    TX_WHITE);

        text_putsa(25,4, " OFF ", TX_WHITE);
        text_putsa(25,5, " INT ", TX_WHITE);
        text_putsa(25,6, " MPU ", TX_WHITE);

        grcg_setcolor(GC_BRGI, 8+5);

        grcg_vline(111, 64, 128);
        grcg_hline(0, 111, 128);

        grcg_vline(239, 64, 112);
        grcg_hline(120, 239, 112);
        grcg_off();
    }

                   /*"FREE: 21832 USED: 15252 "*/
    text_putsa( 0,0, "FREE: 21832 ",                   TX_CYAN|TX_REVERSE);
    text_putsa(12,0, "USED: 15252       ",             TX_CYAN|TX_REVERSE);
    text_putsa(49,0," RECOP V1.2(b2004_0710)     ", TX_GREEN|TX_REVERSE);

    switch (sys_mode) {
      case 0:
      case 2:
      case 4:
        if (play_stop == 0)
          text_putsa(30,0, "        PLAY       ",      TX_YELLOW|TX_REVERSE);
        else
          text_putsa(30,0, "        STOP       ",      TX_MAGENTA|TX_REVERSE);
        break;
      case 1:
        text_putsa(30,0, "  EDIT             ",        TX_YELLOW|TX_REVERSE);
        break;
      case 3:
      case 5:
        text_putsa(30,0, "    MAIN COMMAND   ",        TX_YELLOW|TX_REVERSE);
        break;
    }

    if (sys_mode == 0 || sys_mode == 1 || sys_mode == 4) {
        /* gbN\ */
        p = pointb[disp_tr] + 0x0008;
        for (i = 0; i < 30; i++)
            line_data[i] = *p++;
        line_data[i] = 0;
        check_s_jis();
        text_putsa(0, 1, line_data, TX_YELLOW);

        /* gbNԍ\ */
        sprintf(line_data, "%2d", disp_tr + 1);
        text_putsa(4, 2, line_data, TX_WHITE);
    }
    if (sys_mode == 0 || sys_mode == 1) {
        text_putsa(0, 3, "MEAS STEP:NOTE K#  ST  GT VEL ",TX_GREEN|TX_REVERSE);
    }
    if (sys_mode == 0 || sys_mode == 1)
      text_putsa(0, 2, " TR:18               STEP:255", TX_WHITE);

    if (sys_mode == 3) {
        /* ^Cg\ */
        text_putsa(0, 1, "        TITLE:", TX_CYAN|TX_REVERSE);
        p = &fdata[0x0020];
        line_data[0] = ' ';
        for (i = 1; i < 65; i++) {
            j = *p++;
            line_data[i] = (j == 0) ? ' ' : j;
        }
        line_data[i++] = ' ';
        line_data[i] = 0;
        check_s_jis();
        text_putsa(14,1, line_data, TX_WHITE|TX_REVERSE);
    }

    if (sys_mode == 4) {
        text_putsa( 0, 3, " RHYTHM NAME  ", TX_GREEN|TX_REVERSE);
        text_putsa(14, 3, "25                        ", TX_GREEN|TX_REVERSE);
        text_putsa(40, 3, "        26          ", TX_GREEN|TX_REVERSE);
        text_putsa(60, 3, "                    ", TX_GREEN|TX_REVERSE);
        for (i = 4; i <=19; i++) {
            text_putsa( 0, i, " ", TX_CYAN|TX_REVERSE);
            text_putsa(13, i, " ", TX_CYAN|TX_REVERSE);
            text_putsa(79, i, " ", TX_CYAN|TX_REVERSE);
        }
        text_putsa( 0, 20, " ------------ ", TX_CYAN|TX_REVERSE);
        text_putsa( 0, 21, " GT ", TX_CYAN|TX_REVERSE);
        text_putsa( 7, 21, "<", TX_CYAN|TX_REVERSE);
        text_putsa(11, 21, " ", TX_CYAN|TX_REVERSE);
        text_putsa( 0, 22, " VEL", TX_CYAN|TX_REVERSE);
        text_putsa( 7, 22, ">", TX_CYAN|TX_REVERSE);
        text_putsa(11, 22, " ", TX_CYAN|TX_REVERSE);
        text_putsa(79, 20, " ", TX_CYAN|TX_REVERSE);
        text_putsa(79, 21, " ", TX_CYAN|TX_REVERSE);
        text_putsa(79, 22, " ", TX_CYAN|TX_REVERSE);

        grcg_setcolor(GC_BRGI, 8+5);
        grcg_hline(0, 639, 368);
        grcg_off();

        text_putsa( 1, 4, "Crash Cym   ", TX_WHITE);
        text_putsa( 1, 5, "Ride Cym    ", TX_WHITE);
        text_putsa( 1, 6, "Open HiHat  ", TX_WHITE);
        text_putsa( 1, 7, "Clsd HiHat  ", TX_WHITE);
        text_putsa( 1, 8, "Melo Tom    ", TX_WHITE);
        text_putsa( 1, 9, "Melo Tom    ", TX_WHITE);
        text_putsa( 1,10, "Melo Tom    ", TX_WHITE);
        text_putsa( 1,11, "Melo Tom    ", TX_WHITE);
        text_putsa( 1,12, "Melo Tomm   ", TX_WHITE);
        text_putsa( 1,13, "Snare Drm   ", TX_WHITE);
        text_putsa( 1,14, "Rim Shot    ", TX_WHITE);
        text_putsa( 1,15, "Bass Drm    ", TX_WHITE);
        text_putsa( 1,16, "            ", TX_WHITE);
        text_putsa( 1,17, "            ", TX_WHITE);
        text_putsa( 1,18, "            ", TX_WHITE);
        text_putsa( 1,19, "            ", TX_WHITE);

        line_data[0] = 0xa5;  /* p_ */
        line_data[1] = 0;
        for (j = 4; j <=19; j++) {
            for (i = 15; i <= 77; i=i+2) {
                text_putsa(i, j, line_data, TX_WHITE);
            }
        }
        for (i = 14; i <= 74; i=i+4) {
            text_putsa(i, 21, "12", TX_WHITE);
        }
        for (i = 16; i <= 76; i=i+4) {
            text_putsa(i, 22, "12", TX_WHITE);
        }
    }

    if (sys_mode == 5) {
        text_putsa(0, 3, " TRACK SETTING ", TX_YELLOW|TX_REVERSE);
        text_putsa(0, 4, "Tr.Mode CH. ST+ K#+ RHY ----- MEMO ---------------",
                   TX_CYAN|TX_REVERSE);
        text_putsa(50, 4, "----------  STEP     TOTAL ST ",
                   TX_CYAN|TX_REVERSE);
        for (i = 0; i < 18; i++) {
            sprintf(line_data, "%2d", i + 1);
            text_putsa(0, i+5, line_data, TX_CYAN|TX_REVERSE);
            text_putsa(3, i+5, "Play M 1   0   0 OFF", TX_WHITE);
            p = pointb[i] + 0x0008;
            for (j = 0; j < 36; j++)
              line_data[j] = *p++;
            line_data[j] = 0;
            check_s_jis();
            text_putsa(24, i+5, line_data, TX_WHITE);
            text_putsa(61, i+5, "16371     16777215", TX_WHITE);
        }
        grcg_setcolor(GC_BRGI, 8+5);
        grcg_vline(16, 80, 367);
        grcg_vline(17, 80, 367);
        grcg_vline(18, 80, 367);
        grcg_vline(60, 80, 367);
        grcg_vline(92, 80, 367);
        grcg_vline(124, 80, 367);
        grcg_vline(156, 80, 367);
        grcg_vline(188, 80, 367);
        grcg_vline(484, 80, 367);
        grcg_vline(532, 80, 367);
        grcg_vline(639, 80, 367);
        grcg_hline(0, 639, 368);
        grcg_off();
        set_cursor(6, 5);
    }

    if (sys_mode == 1 || sys_mode == 4) {
        text_putsa( 4, 24, " 192  ", TX_YELLOW|TX_REVERSE);
        text_putsa(11, 24, " 144  ", TX_YELLOW|TX_REVERSE);
        text_putsa(18, 24, "  96  ", TX_YELLOW|TX_REVERSE);
        text_putsa(25, 24, "  72  ", TX_YELLOW|TX_REVERSE);
        text_putsa(32, 24, "  48  ", TX_YELLOW|TX_REVERSE);
        text_putsa(42, 24, "  36  ", TX_YELLOW|TX_REVERSE);
        text_putsa(49, 24, "  24  ", TX_YELLOW|TX_REVERSE);
        text_putsa(56, 24, "  18  ", TX_YELLOW|TX_REVERSE);
        text_putsa(63, 24, "  12  ", TX_YELLOW|TX_REVERSE);
        text_putsa(70, 24, "   6  ", TX_YELLOW|TX_REVERSE);
    }
    if (sys_mode == 3) {
        display_smemo();    /* \O */
        display_tmemo();
        text_putsa( 1, 24, " RECORD ", TX_WHITE|TX_REVERSE);
        text_putsa(10, 24, " PLAY ", TX_WHITE|TX_REVERSE);
        text_putsa(17, 24, " EDIT ", TX_WHITE|TX_REVERSE);
        text_putsa(24, 24, " SUB ", TX_WHITE|TX_REVERSE);
        text_putsa(30, 24, " TR.set ", TX_WHITE|TX_REVERSE);
        text_putsa(40, 24, " LOAD ", TX_WHITE|TX_REVERSE);
        text_putsa(47, 24, " SAVE ", TX_WHITE|TX_REVERSE);
        text_putsa(54, 24, " DISK ", TX_WHITE|TX_REVERSE);
        text_putsa(61, 24, " INSTALL ", TX_WHITE|TX_REVERSE);
        text_putsa(71, 24, " GS/GM ", TX_WHITE|TX_REVERSE);
    }
}

/*----------------------------------------------*/
void skip_to_the_count(void);  /* O[oJEg܂őSgbNi߂ */
void get_count(void);   /* f[^AhXO[oJEg߂ */

void play_init(void);
int play_loop(void);
int play_main(void);
void tr_main(void);
int main_command1(void);
int main_command2(void);
int play_monitor(int k);
int set_vacant_data(void); /* RCP̏f[^ */

void play_init() /* 2003 */
{
    disp_tr_prev = -1;

    init_data();
    intc1 = 0;
    intc2 = -1;
    disp_step = 1;
    disp_meas = 1;
    disp_tr = 0;
    disp_p = pointb[disp_tr] + 0x002c; /* gbN̊Jnʒu */
    sys_mode = 1;
}

void indicator(void);
void indicator()
{
    static int i = 0;

    sprintf(line_data, "%2d", i++);
    text_putsa(78, 24, line_data, TX_WHITE);
    i &= 63;
}

int play_loop() /* 2003 */
{
    int i, tmp, k;

    my_sleep();

    for (i = 0; i < 18; i++) {
        if (!endfs[i]) goto m2;
    }
    for (i = 0; i < 18; i++) endfs[i] = 0;
    goto m6;
  m2:
    k = key_check();
    if (k == ' ' && sys_mode == 0) {
        sys_mode = 2;
        gamen_start();
    }
    if (k == 0x0c) { /* Home tꎞ~ */
        play_stop = 1 - play_stop;
        if (play_stop == 1) {
            key_off_18tr();     /*LĂSĂnotenote off*/
            text_putsa(30,0, "        STOP       ", TX_MAGENTA|TX_REVERSE);
        }
        else {
            text_putsa(30,0, "        PLAY       ", TX_YELLOW|TX_REVERSE);
        }
    }
    if (k == 0x1b || k == 0x17) { /* ESC ܂ Shift+Home */
      m6:
        key_off_18tr();           /*LĂSĂnotenote off*/
        if (shift || k == 0x17) { /* SHIFT+ESC ܂ Shift+Home ̏ꍇ */
                                  /* tfʒuҏWʒuɂ */
            home_p = pointb[disp_tr] + 0x002c;
            /* EDIT[hŕ\擪s */
            /* iJnƓ߂ŒfĂҏWsSsɂȂj */
        }
        else {
            disp_tr = ret_tr;  /* tJnʒuҏWʒuɖ߂ */
            disp_p = ret_p;
        }
        trans_to_meas();
        return(0x1b);
    }
    if (k == 'n' && sys_mode == 0)   /* n */  /* ] */
      rhythm_mode[disp_tr] = rhythm_mode[disp_tr] ^ 0x80; /*Y 0x80*/
    if (sys_mode == 2) {
        if (disp_tr_prev != disp_tr) {
            sys_mode = 0;
            gamen_start();
        }
        else {
            if (play_monitor(k) || k != 0) goto m7;
            return(0);
        }
    }
    tmp = intc1;  /* intc2ւ̑܂łɃ^C}[݂ꍇl */
    if (k == 0 && tmp == intc2)
      return(0);
    intc2 = tmp;

    display_text();  /* ʕ`(eLXg) */
    display_graph(); /* ʕ`(Ot) */
    display_kenban();/* ʕ`(Օ) */
  m7:
    disp_tr_prev = disp_tr;

    indicator();
    my_bitblt();
    return(0);
}

int play_main()  /* P: vCR}h */
{
    int k;

    while (1) {
        k = play_loop();
        if (k == 0x1b) break;
    }
    if (shift)
      return(1); /* tfʒuҏWʒuɂ */
    else
      return(0); /* tJnʒuҏWʒuɂ */
}

void tr_main()  /* TrҏWC */
{
    int k;

    disp_tr_prev = -1;  /* ` */
    sys_mode = 1;  /* 1..TrҏW(Tr\) */
    gamen_start();
    while (1) {
        my_sleep();

        k = key_check_edit();
        if (k == 0 && disp_tr_prev != -1) continue;
        if (k == 0x1b) {  /* ESC */
            return;
        }
        if (disp_tr_prev != disp_tr) {
            trans_to_p();  /* trύXɔmeasstepɂpւ̒Ǐ]ϊ */
        }
        if (k == 'p') {
            play_stop = 0;
            skip_point = disp_p - pointb[disp_tr];
            ret_tr = disp_tr;
            ret_p = disp_p;
            text_putsa(30,0, "     POINT PLAY", TX_YELLOW|TX_REVERSE);
            skip_to_the_count(); /* O[oJEg܂őSgbNi߂ */
            disp_tr_prev = -1;
            sys_mode = 0;  /* 0..t(Tr\) */
            gamen_start();
            play_main();   /* Trʉt */
            sys_mode = 1;  /* 1..TrҏW(Tr\) */
            gamen_start();
            disp_tr_prev = -1;
        }
        analyze_key(k);

        display_text();  /* ʕ`(eLXg) */
        display_graph(); /* ʕ`(Ot) */
        display_kenban();/* ʕ`(Օ) */
        disp_tr_prev = disp_tr;

        indicator();
        my_bitblt();
    }
}

int play_monitor(int k)
{
    int i, j, vel;
    static int t;

    if (k == 0 && t == g_count) return(0);
    t = g_count;
    /* Velocity̌_Ot` */
    for (i = 0; i < 18; i++) {
        vel = velgraph[i] / 2;
        if (vel <= 124) {
            grcg_setcolor(GC_BRGI, 0); /*  */
            grcg_boxfill(72+i*32, 352, 87+i*32, 352+(31 - (vel+3)/4));
        }
        if (vel >= 1) {
            if (vel >= 80)
              grcg_setcolor(GC_BRGI, 8+2); /*  */
            else
              grcg_setcolor(GC_BRGI, 8+4); /*  */
            grcg_boxfill(72+i*32, 352+(31 - (vel-1)/4), 87+i*32, 383);
        }
    }
    grcg_off();
    return(1);
}

void prog_main() /* win.cĂ΂֐ */
{
    extern int flag_drop;
    extern char filename[];
    int k;

    if (set_vacant_data() != 0) return;  /* mێs */
    if (filename[0] != 0)
      read_file(); /* t@Cǂݍ */
    play_init();   /* f[^ */
    while (1) {
        k = main_command1();
        if (k == 'Q') return;
        if (k == 'L') {
            if (flag_drop == 1) {
                flag_drop = 0;
                read_file(); /* t@Cǂݍ */
                play_init(); /* f[^ */
            }
        }
        if (k == 'P') {
            play_stop = 0;
            skip_point = 0x2c;
            ret_tr = disp_tr;
            ret_p = disp_p;
            home_p = disp_p;
            skip_to_the_count();
            disp_tr_prev = disp_tr;
            sys_mode = 2;  /* 2..t(S̕\) */
            gamen_start();
            if (play_main())  /* Sʉt */
              goto m1;        /* tIATrҏW */
        }
        if (k == 0x0d) { /* Trԍwς݁A͏ߎw */
            while (1) {
                if (main_command2() != 0x0d) break;
                home_p = disp_p;
              m1:
                tr_main();  /* MEAS/STEPwς݁ATrҏW */
            }
        }
    }
}

/*----------------------------------------------*/

int get_number1(int x, int y, int max, int *val, char *fmt, int keta)
{
    int n, k, f;

    n = *val;
    f = 0;  /* OlptO */
    sprintf(line_data, fmt, n);
    text_putsa(x, y, line_data, TX_WHITE);
    set_cursor(x + keta - 1, y);
    my_bitblt();
    while (1) {
        my_sleep();
        k = get_key();
        if (k == 0) {
            continue;
        }
        else if (k >= '0' && k <= '9') {
            if (f == 0) {
                f = 1;
                n = k - '0';
            }
            else {
                n = n * 10 + k - '0';
                if (n > max) n = n % (max + 1);
            }
        }
        else if (k == 0x07) { /* Del */
            n = n / 10;
        }
        else if (k == 0x0d) { /* Enter */
            *val = n;         /* ̕ϐɒln */
            break;
        }
        else if (k == 0x1b) { /* Esc */
            break;
        }
        else {
            break;            /* zÕL[͂̏ꍇ */
        }
        sprintf(line_data, fmt, n);
        text_putsa(x, y, line_data, TX_WHITE);
        set_cursor(x + keta - 1, y);
        my_bitblt();
    }
    set_cursor(-1, -1);
    return(k);  /* ̊֐甲錴ƂȂL[Ԃ */
}

int main_command1()
{
    int k, tr0;

    sys_mode = 3;
    gamen_start();

    tr0 = disp_tr + 1;

    text_putsa(0, 2, "TR:", TX_CYAN|TX_REVERSE);
    k = get_number1(4, 2, 99, &tr0, "%2d", 2);
    if (k != 0x0d) return(k);

    if (tr0 >= 1 && tr0 <= 18)
      disp_tr = tr0 - 1;
    return(k);
}

int main_command2()
{
    int k, meas0, step0;

    meas0 = disp_meas;
    step0 = disp_step;

  m1:
    text_putsa(30,0, "  EDIT          ", TX_YELLOW|TX_REVERSE);
    text_putsa( 8, 2, "MEAS", TX_CYAN|TX_REVERSE);
    text_putsa(16, 2, "             ", TX_WHITE);
    k = get_number1(12, 2, 9999, &meas0, "%4d", 4);
    if (k == 0x1b) return(k);
    if (k != 0x0d) goto m1;
  m2:
    text_putsa(16, 2, "STEP", TX_CYAN|TX_REVERSE);
    k = get_number1(20, 2, 9999, &step0, "%4d", 4);
    if (k == 0x1b) goto m1;
    if (k != 0x0d) goto m2;

    disp_meas = meas0;
    disp_step = step0;
    trans_to_p();  /* trύXɔmeasstepɂpւ̒Ǐ]ϊ */
    return(k);
}

/*----------------------------------------------*/

int read_file()
{
    extern char filename[];
    struct stat sbuf;
    int n;
    FILE *fp;

    stat(filename, &sbuf);
    n = sbuf.st_size;
    if (n == 0) {
        dbg_str("File size 0 or directory"); /* ̃t@C̓fBNg */
        return(0);
    }
    if (n > 1180990) {
        dbg_str("Too big file"); /* zȎ傫 */
        return(0);
    }
    fp = fopen(filename, "rb");
    fread(fdata, n, 1, fp);
    fclose(fp);
    {
        char *p = "RCM-PC98V2.0(C)COME ON MUSIC";
        int i;

        for (i = 0; i < 28; i++) {
            if (fdata[i] != p[i]) {
                dbg_str("Not RCP format file"); /* RCPt@CłȂ */
                set_vacant_data();
                return(0);
            }
        }
    }
    return(1);
}

void init_data()
{
    int   i, j;
    int   min = 384;
    uchar *mem, *p;

    tempo = fdata[0x01c1];
    settempo(64); /* bias 0ŃZbg */
    play_bias = fdata[0x01c5];
    kbias = (12 - kbias_trans[fdata[0x01c4] % 16]) % 12;

    for (i = 0; i < 128; i++) {
        drum_name[i] = 0;
    }
    for (i = 0; i < 32; i++) {
        drum_name[fdata[0x0214+i*16]] = 0x0206+i*16;
    }

    for (i = 0; i < 18; i++) {
        if (i == 0)
          pointb[0] = fdata + 0x0586;
        else
          pointb[i] = pointb[i-1] + *(pointb[i-1]+0) + *(pointb[i-1]+1)*256;
        points[i] = pointb[i] + 0x002c; /*egbN̊Jnʒu*/
        mem = pointb[i];
        rhythm_mode[i] = mem[3];    /* Y on..0x80 off..0x00 */
        tr_ch[i] = mem[4] & 0x0f;   /* `lԍ M1`16R1`16ꎋ */
        key_bias[i] = mem[5];       /* KEY#+l */
        st_bias[i] = mem[6];        /* STl */
        tr_mode[i] = mem[7];        /* MODE (0:Play 1:Mute 2:Mix 4:Rec) */
        counts[i] = st_bias[i] + 256; /* STl (bug fix 2004.7.10) */
        meass[i] = 1;
        endfs[i] = 0;

        rol_ex_data[i][0]  = 0xf0;
        rol_ex_data[i][1]  = 0x41;
        rol_ex_data[i][2]  = 0x10;
        rol_ex_data[i][3]  = 0x16;
        rol_ex_data[i][4]  = 0x12;
        rol_ex_data[i][5]  = 0x10;
        rol_ex_data[i][6]  = 0x00;
        rol_ex_data[i][7]  = 0x00;
        rol_ex_data[i][8]  = 0x00;
        rol_ex_data[i][9]  = 0x00;
        rol_ex_data[i][10] = 0xf7;

        /* note on/offǗz񏉊 */
        ons[i] = 0;
        for (j = 0; j < 16; j++) {
            r_step[i][j] = 0;
            r_key[i][j] = 0;
        }
        velgraph[i] = 0;

        /* same measAloop֘A */
        lp_s[i] = NULL;
        lp_ln[i] = 0;

        /* ŏl߂ */
        if (min > counts[i])
            min = counts[i];
    }

    for (i = 0; i < 18; i++) {
        counts[i] = counts[i] - min + 10;  /* 10:傢Ɨ]T܂ */
    }
    g_count = 0;                          /* O[oJEg */
}

char *rhythm_name[] = { /* Y̖OK#() */
    "HandClap      '","MuteHighConga >","OpenHighConga ?","LowConga      @",
    "CrashCymbal1  1","RideCymbal1   3","PedalHi-hat   ,","OpenHi-hat    .",
    "ClosedHi-hat  *","HighTom2      0","MidTom2       -","LowTom2       )",
    "SideStick     %","SnareDrum2    (","SnareDrum1    &","KickDrum1     $",
    "HighTimbale   A","LowTimbale    B","Cowbell       8","HighBongo     <",
    "LowBongo      =","HighAgogo     C","LowAgogo      D","Tambourine    6",
    "Claves        K","Maracas       F","LongLowWhistleH","ShortHiWhistleG",
    "Cabasa        E","ShortGuiro    I","MuteTriangle  P","OpenTriangle  Q"};

int set_vacant_data() /* RCP̏f[^ */
{
    int i, j;
    char *p;

    if (fdata == NULL) {
        fdata = malloc(1180990); /* 18gbNōlő̃TCY */
                             /* 0x0586 + (0x2c+0xffd0) * 18 = 0x12053eoCg */
        if (fdata == NULL) {
            dbg_str("܂");
            return(1);
        }
    }

    /* wb_[ */
    strcpy(fdata, "RCM-PC98V2.0(C)COME ON MUSIC");
    fdata[0x1c] = 0x0d;
    fdata[0x1d] = 0x0a;
    fdata[0x1e] = 0x00;
    fdata[0x1f] = 0x00;
    for (i = 0x20; i < 0x1b0; i++)
      fdata[i] = ' '; /* ^CgƃNA */
    for (i = 0x1b0; i < 0x1c0; i++)
      fdata[i] = 0x40;   /* prs̃f[^ */
    fdata[0x01c0] = 48;  /* ^Cx[X */
    fdata[0x01c1] = 120; /* e| */
    fdata[0x01c2] = 4;   /* q */
    fdata[0x01c3] = 4;   /* q */
    fdata[0x01c4] = 0;   /* KEY */
    fdata[0x01c5] = 0;   /* play bias SgbNΏۂK# */
    for (i = 0x1c6; i < 0x206; i++)
      fdata[i] = 0;      /* prs̃f[^ */
    fdata[0x01e6] = 18;  /* 18gbNdl */
    /* Y` */
    for (i = 0; i < 32; i++) {
        p = fdata + 0x0206 + 0x10*i;
        strcpy(p, rhythm_name[i]); /* Y̖OK# */
        p[15] = 1;                 /* YGT */
    }
    /* [U`GNXN[Vuf[^ */
    for (i = 0; i < 8; i++) {
        p = fdata + 0x0406 + 0x30*i;
        strcpy(p, "USER EXCLUSIVE 1        "); /*  */
        p[15] = '0' + i;
        for (j = 24; j < 48; j++)
          p[j] = 0xf7;                         /* Exclsv f[^*/
    }
    /* gbNf[^ */
    for (i = 0; i < 18; i++) {
        p = fdata + 0x0586 + 0x30*i;
        p[0] = 0x30;    /* gbÑf[^TCY() */
        p[1] = 0;       /* gbÑf[^TCY() */
        p[2] = i + 1;   /* gbNԍ */
        p[3] = 0;       /* Y[hOFF */
        if (i < 16)
          p[4] = i;     /* `lԍ(1`16gbN) */
        else
          p[4] = 0xff;  /* `lԍ(17`18gbN) */
        p[5] = 0;       /* K#+l */
        p[6] = 0;       /* ST+l */
        p[7] = 0;       /* gbN[hPlay */
        for (j = 8; j < 0x2c; j++)
          p[j] = ' ';   /* Rg */
        p[0x2c] = 0xfe; /* gbNGh */
        p[0x2d] = 0xfe; /* gbNGh */
        p[0x2e] = 0xfe; /* gbNGh */
        p[0x2f] = 0xfe; /* gbNGh */
    }
    return(0);
}

void display_tmemo()  /* gbN\ */
{
    int   i, j, k;
    char  *p;

    text_putsa(31,4, "TR MODE CH. TRACK MEMO                           ",
               TX_REVERSE|TX_GREEN);
    for (i = 0; i < 18; i++) {
        sprintf(&line_data[0], "%2d", i+1);
        text_putsa(31,i+5, line_data, TX_REVERSE|TX_GREEN);
        k = *(pointb[i] + 4);
        sprintf(&line_data[0], "Play M%2d", k+1);
        text_putsa(34,i+5, line_data, TX_WHITE);
        line_data[0] = ' ';
        p = pointb[i] + 8;
        for (j = 1; j < 37; j++) {
             k = *p++;
             line_data[j] = (k == 0) ? ' ' : k;
        }
        line_data[j++] = ' ';
        line_data[j] = 0;
        check_s_jis();
        text_putsa(42,i+5, line_data, TX_WHITE);
    }

    /* DOS/VlAOtBbNɕ` */
    grcg_setcolor(GC_BR, 3);
    grcg_vline(80*8-1, 5*16, 23*16-1);
    grcg_vline(39*8-5, 5*16, 23*16-1);
    grcg_vline(43*8-5, 5*16, 23*16-1);
    grcg_hline(31*8, 80*8-1, 23*16-1);
    grcg_off();
}

void display_smemo()  /* \O\ */
{
    int   i, j, k;
    char  *p;

    text_putsa(0,10, " SONG MEMO                    ", TX_REVERSE|TX_YELLOW);

    p = fdata + 0x0060;  /* C 2003 */
    for (i = 0; i < 12; i++) {
        text_putsa(0,i+11, " ", TX_REVERSE|TX_CYAN);
        for (j = 0; j < 28; j++) {
             k = *p++;
             line_data[j] = (k == 0) ? ' ' : k;
        }
        line_data[j++] = ' ';
        line_data[j] = 0;
        check_s_jis();
        text_putsa(1,i+11, line_data, TX_WHITE);
    }
    grcg_setcolor(GC_BRGI, 8+5);
    grcg_vline(30*8-1, 11*16, 23*16-1);
    grcg_hline(0, 30*8-1, 23*16);
    grcg_off();
}

/* VtgihrPڂŕ񂪏IĂA؂̂Ă */
void check_s_jis()
{
    uint  a;
    uchar *p;

    p = line_data;
    while (1) {
        a = *p++;
        if (a == 0) return;
        if (a < 0x80 || a >= 0xa0 && a < 0xe0) continue;
        if (*p == 0) {
            p--;
            *p = ' ';
            return;
        }
        p++;
    }
}

/*----------------------------------------------*/

void get_count()   /* f[^AhXO[oJEg߂ */
{
    ctr = disp_tr;
    g_count = counts[ctr];
    pointc = points[ctr];
    while (1) {
        if (pointc - pointb[ctr] >= skip_point)
            break;
        rec0 = pointc[0];
        rec1 = pointc[1];
        if (rec0 < 0xf0) {
            g_count += rec1;
            pointc += 4;
            continue;
        }
        rec2 = pointc[2];
        rec3 = pointc[3];
        switch (rec0) {
          case 0xf8:                    /* Loop End */
            loop_end();
            break;
          case 0xf9:                    /* Loop Begin */
            loop_begin();
            break;
          case 0xfc:                    /* Same Measure */
            same_meas();
            break;
          case 0xfd:                    /* Measure End */
            meas_end();
            break;
          case 0xfe:                    /*gbNGh*/
            if (lp_s[ctr] != NULL) {
                pointc = lp_s[ctr];
                lp_s[ctr] = NULL;
                break;
            }
            goto m1;
        }
        pointc += 4;
    }
  m1:;
}

void skip_to_the_count()  /* O[oJEg܂őSgbNi߂ */
{
    int i, st, target_g_count;
    int  pit2[18], pit3[18], con1[18], con7[18], con10[18], con11[18];

    for (i = 0; i < 18; i++)
      pit2[i] =pit3[i] = con1[i] = con7[i] = con10[i] = con11[i] = -1;

    init_data();
    get_count(); /* f[^AhXO[oJEg߂ */
    target_g_count = g_count;
    init_data();

    while (g_count < target_g_count - 1) {
        g_count++;

        for (i = 0; i < 18; i++) {
            ctr = i;
            counts[i]--;
            if (counts[i])
              continue;
            pointc = points[i];
            measc = meass[i];
            while (1) {
                cur_mode = tr_mode[i] & 0x19; /* Mix  Rec ̃tO͖ */
                if (cur_mode == 0)
                  cur_mode = 2;           /* o͋KȂ*/
                else if (cur_mode == 16)
                  cur_mode = 1;           /* o͋KiNOTE ON̂݁j*/
                else
                  cur_mode = 0;           /* o͋KiׂĂMIDI OUTj*/

                rec0 = pointc[0];
                rec1 = pointc[1];
                rec2 = pointc[2];
                rec3 = pointc[3];

                if (rec0 < 0xf0)
                  st = rec1;
                else
                  st = 0;

                if (rec0 < 0x80) {
                    ;  /*check_key_on();*/
                }
                else if (rec0 >= 0x90 && rec0 <= 0x97) {
                    usr_excl();                    /* USER EX1`8 */
                } else {
                    switch (rec0) {
                      case 0x98:                   /*gbNGNXN[Vu*/
                        tr_excl();
                        break;
                      case 0xdd:                   /* Rol Base */
                        rol_base();
                        break;
                      case 0xde:                   /* Rol Para */
                        rol_para();
                        break;
                      case 0xdf:                   /* Rol Dev */
                        rol_dev();
                        break;
                      case 0xe2:                   /* Bank & Prog */
                        bank_program();
                        break;
                      case 0xe5:                   /* Key Scan */
                        break;
                      case 0xe6:                   /* MIDI Ch change */
                        midi_channel();
                        break;
                      case 0xe7:                   /*e|`FW*/
                        settempo(rec2);            /*graduation͖*/
                        break;
                      case 0xea:                   /* Ch Pressure */
                        ch_pressure();
                        break;
                      case 0xeb:                   /*Rg[`FW*/
                        switch (rec2) {
                          case   1: con1[i] = rec3; break;
                          case   7: con7[i] = rec3; break;
                          case  10: con10[i]= rec3; break;
                          case  11: con11[i]= rec3; break;
                          case   6:
                          case  98:
                          case  99:
                          case 100:
                          case 101:
                          case 121:
                          case 126:
                          case 127:
                          case  64:         /* _p[ */
                          case   0:         /* bank select */
                          case  32:         /* bank select */
                          case  91:         /* reverb */
                          case  93:         /* chorus */
                            goto m2;
                          default:
                          m2:
                            midi_out(rec3 * 0x10000 + rec2 * 0x100
                                     + 0xb0 + tr_ch[i]);
                        }
                        break;
                      case 0xec:                   /*vO`FW*/
                        midi_out(rec2 * 0x100 + 0xc0 + tr_ch[i]);
                        break;
                      case 0xed:                   /* Key Pressure */
                        key_pressure();
                        break;
                      case 0xee:                   /*sb`xh*/
                        pit2[i] = rec2;
                        pit3[i] = rec3;
                        break;
                      case 0xf5:                   /* Key Change */
                        kbias = (12 - kbias_trans[rec1 % 16]) % 12;
                        break;
                      case 0xf8:                   /* Loop End */
                        loop_end();
                        break;
                      case 0xf9:                   /* Loop Begin */
                        loop_begin();
                        break;
                      case 0xfc:                   /* Same Measure */
                        same_meas();
                        break;
                      case 0xfd:                   /* Measure End */
                        meas_end();
                        break;
                      case 0xfe:                   /*gbNGh*/
                        if (lp_s[ctr] != NULL) {
                            measc++;
                            pointc = lp_s[ctr];
                            lp_s[ctr] = NULL;
                            break;
                        }
                        endfs[ctr] = 1;
                        goto m1;
                    }
                }
                pointc += 4;

                if (st == 0)
                  continue;
                counts[i] += st;
                break;
            }
          m1:
            points[i] = pointc;
            meass[i] = measc;
        }
    }

    for (i = 0; i < 18; i++) {
        if (pit2[i] != -1)
          midi_out(pit3[i] * 0x10000 + pit2[i] * 0x100 + 0xe0 + tr_ch[i]);
        if (con1[i] != -1)
          midi_out(con1[i] * 0x10000 + 1 * 0x100 + 0xb0 + tr_ch[i]);
        if (con7[i] != -1)
          midi_out(con7[i] * 0x10000 + 7 * 0x100 + 0xb0 + tr_ch[i]);
        if (con10[i] != -1)
          midi_out(con10[i] * 0x10000 + 10 * 0x100 + 0xb0 + tr_ch[i]);
        if (con11[i] != -1)
          midi_out(con11[i] * 0x10000 + 11 * 0x100 + 0xb0 + tr_ch[i]);
    }

    skip_point = 0;
}

void settempo(uint bias)
{
    /*e|^C}荞ݎZbg*/
    uint tmp;

    tmp = (tempo * bias + 33) / 64;  /* { 32 {ƍ킹 33 */
                                     /* (65*95/64 = 96.484  97 ɂȂ) */
    if (tmp < 10)  tmp = 10;
    if (tmp > 240) tmp = 240;
    delta = (12500000 / tmp + 5 ) / 10; /*SPʂ̎ԊԊuAľܓl*/
}

char kenban_bias[18];       /* Ղ '<' '>' ł炷 */

void draw_key_on(char k);
void draw_key_off(char k);

void draw_key_on(char k)
{
    uchar l, h;
    int   kx, ky;

    k = k + kenban_bias[disp_tr];
    if (k < 36)
        k = 35;
    else if (k > 100)
        k = 101;
    grcg_setcolor(GC_BRG, 0x07); /*GRCG̃[hѐFݒ*/
    l = k % 12;
    h = k / 12;
    if (l > 4) l++;
    kx = l / 2;
    ky = l % 2;
    kx = 254 + (h*35 - 35*3 + kx*5)*2 + ky*5;
    ky = 18 + 208-32+1 - ky*6*2 - 158;
    grcg_boxfill(kx, ky, kx+4, ky+7);
    grcg_off();
}

void draw_key_off(char k)
{
    uchar l, h, f;
    int   kx, ky;

    k = k + kenban_bias[disp_tr];
    f = 0;
    if (k < 36) {
        k = 35;
        f = 1;
    }
    else if (k > 100) {
        k = 101;
        f = 1;
    }
    l = k % 12;
    h = k / 12;
    if (l > 4) l++;
    kx = l / 2;
    ky = l % 2;
    if (ky || f)
        grcg_setcolor(GC_BRG, 0x00); /*GRCG̃[hѐFݒ*/
    else
        grcg_setcolor(GC_BRG, 0x04); /*GRCG̃[hѐFݒ*/
    kx = 254 + (h*35 - 35*3 + kx*5)*2 + ky*5;
    ky = 18 + 208-32+1 - ky*6*2 - 158;
    grcg_boxfill(kx, ky, kx+4, ky+7);
    grcg_off();
}

void display_kenban()
{
    uchar *p_cur;
    int tone[128]; /* charł͕s */
    int i;

    if (sys_mode == 0) {
        p = lp_s[disp_tr];
        if (p == 0) {              /* same measłȂ */
            p = points[disp_tr];   /* tʒu */
            if (!endfs[disp_tr])
              prev_data();  /* Ps߂(p̂) */
        }
    }
    else {
        p = disp_p;
    }
    p_cur = p;

    for (i = 0; i < 127; i++) tone[i] = 0;
    meas_top();      /* pߐ擪AhXɖ߂ */
    while (1) {  /* Jg܂Ői߂ */
        uchar k;

        k = p[0];
        if (k >= 0xfc) break; /* fc:same meas,fd:meas end,fe:track end */
        if (k < 0xf0) {
            if (k < 0x80 && p[2] != 0 && p[3] != 0) {
                tone[k] = p[2];
            }
            if (p == p_cur) break;
            if (p[1]) {
                for (i = 0; i < 127; i++) {
                    if (tone[i]) {
                        tone[i] -= p[1];
                        if (tone[i] < 0) tone[i] = 0;
                    }
                }
            }
        }
        p += 4;
    }
    for (i = 36; i < 101; i++)
      if (tone[i])
        draw_key_on(i);
      else
        draw_key_off(i);
}

/* 128 144 96 72 48 36 24 18 12 6   normal */
/* 192 168 64 84 32 42 16 21  8 4   shift  */
