#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

typedef unsigned int uint;
typedef unsigned char uchar;

void sequence(void);
void check_key_off(void);     /*gate-1ēKXkey off*/
void check_key_on(void);

void usr_excl(void);      /* 90-97 UsrExc   */
void tr_excl(void);          /* 98 Tr.Excl  */
void rol_base(void);         /* dd RolBase  */
void rol_para(void);         /* de RolPara  */
void rol_dev(void);          /* df RolDev#  */
void bank_program(void);     /* e2 BankPrg  */
void midi_channel(void);     /* e6 MIDI CH. */
void ch_pressure(void);      /* ea AFTER C. */
void key_pressure(void);     /* ed AFTER K. */
void loop_end(void);         /* f8    ]     */
void loop_begin(void);       /* f9    [     */
void same_meas(void);        /* fc ======== */
void meas_end(void);         /* fd -------- */

extern void settempo(uint bias);
extern void midi_out(int data);
extern void midi_out_long(char *p, int n);
extern void dbg_disp(int i);
extern void dbg_str(char *p);

extern int intc1;
extern uchar *fdata;

uchar  ons[18];         /* Ă鉹̐Bő16 */
uchar  r_step[18][16];  /* c蔭Xebv */
uchar  r_key[18][16];   /* Ăj */
uchar  velgraph[18];    /* Velocity_Otp */

int counts[18];
uchar *pointb[18];      /* egbÑx[X|Cg */
uchar *points[18];      /* egbÑJg|Cg */
uchar *pointc;          /* Jg|Cg */
int ctr;                /* JggbN */
char endfs[18];         /* GhtO */
int meass[18];
int measc;              /* Jgߔԍ */

char  play_bias;           /* SgbNΏۂK# */
uchar rhythm_mode[18];     /* Y on..0x80 off..0x00 */
uchar tr_ch[18];           /* gbNoCHΉ\ */
char  key_bias[18];        /* KEY#+l */
char  st_bias[18];         /* STl */
uchar tr_mode[18];         /* MODE (0:Play 1:Mute 2:Mix 4:Rec) */
                           /*      (8:MIDI CH.OFF 16:note֌WOFF) */
uchar rol_ex_data[18][11]; /* Roland Exclusive f[^ */

uchar *lp_s[18];     /* same measIĖ߂ʒuBOȂs.m.łȂ */
uchar *lp_l1[18][5]; /* [v̐擪i[̎j */
uchar *lp_l2[18][5]; /* s.m.[ꍇ́As.m.IĖ߂ʒu */
int  lp_l3[18][5]; /* [vJE^iOBJEgAbvj */
uint lp_l4[18][5]; /* [v擪̏ߔԍ */
uint lp_ln[18];    /* [vo^ */

extern int skip_point;
extern int play_stop;

uchar rec0, rec1, rec2, rec3;
int cur_mode;
int g_count = 0;     /* O[oJEg */

extern int kbias; /* K\p */
extern uchar kbias_trans[16];
extern int disp_tr;
extern char sys_mode;     /* VXe[h(0..t 1..ҏW) */

void sequence()
{
    int  i, st;

    if (skip_point)
        return;

    if (sys_mode != 0 && sys_mode != 2) return; /*t[hłȂΔ*/

    if (play_stop != 0) return; /*tXgbvȂ甲*/

    g_count++;

    for (i = 0; i < 18; i++) {
        ctr = i;
        check_key_off();     /*128egate-1ēKXkey off*/
        counts[i]--;
        if (counts[i])
            continue;
        if (i == disp_tr) intc1++;
        pointc = points[i];
        measc = meass[i];
        while (1) {
            cur_mode = tr_mode[i] & 0x19; /* Mix  Rec ̃tO͖ */
            if (cur_mode == 0)
                cur_mode = 2;           /* o͋KȂ*/
            else if (cur_mode == 16)
                cur_mode = 1;           /* o͋KiNOTE ON̂݁j*/
            else
                cur_mode = 0;           /* o͋KiׂĂMIDI OUTj*/

            rec0 = pointc[0];
            rec1 = pointc[1];
            rec2 = pointc[2];
            rec3 = pointc[3];

            if (rec0 < 0xf0)
              st = rec1;
            else
              st = 0;

            if (rec0 < 0x80) {
                check_key_on();
            }
            else if (rec0 >= 0x90 && rec0 <= 0x97) {
                usr_excl();                    /* USER EX1`8 */
            } else {
                switch (rec0) {
                  case 0x98:                   /*gbNGNXN[Vu*/
                    tr_excl();
                    break;
                  case 0xdd:                   /* Rol Base */
                    rol_base();
                    break;
                  case 0xde:                   /* Rol Para */
                    rol_para();
                    break;
                  case 0xdf:                   /* Rol Dev */
                    rol_dev();
                    break;
                  case 0xe2:                   /* Bank & Prog */
                    bank_program();
                    break;
                  case 0xe5:                   /* Key Scan */
                    break;
                  case 0xe6:                   /* MIDI Ch change */
                    midi_channel();
                    break;
                  case 0xe7:                   /*e|`FW*/
                    settempo(rec2);            /*graduation͖*/
                    break;
                  case 0xea:                   /* Ch Pressure */
                    ch_pressure();
                    break;
                  case 0xeb:                   /*Rg[`FW*/
                    midi_out(rec3 * 0x10000 + rec2 * 0x100 + 0xb0 + tr_ch[i]);
                    break;
                  case 0xec:                   /*vO`FW*/
                    midi_out(rec2 * 0x100 + 0xc0 + tr_ch[i]);
                    break;
                  case 0xed:                   /* Key Pressure */
                    key_pressure();
                    break;
                  case 0xee:                   /*sb`xh*/
                    midi_out(rec3 * 0x10000 + rec2 * 0x100 + 0xe0 + tr_ch[i]);
                    break;
                  case 0xf5:                   /* Key Change */
                    kbias = (12 - kbias_trans[rec1 % 16]) % 12;
                    break;
                  case 0xf8:                   /* Loop End */
                    loop_end();
                    break;
                  case 0xf9:                   /* Loop Begin */
                    loop_begin();
                    break;
                  case 0xfc:                   /* Same Measure */
                    same_meas();
                    break;
                  case 0xfd:                   /* Measure End */
                    meas_end();
                    break;
                  case 0xfe:                   /*gbNGh*/
                    if (lp_s[ctr] != NULL) {
                        measc++;
                        pointc = lp_s[ctr];
                        lp_s[ctr] = NULL;
                        break;
                    }
                    endfs[ctr] = 1;
                    goto m1;
                }
            }
            pointc += 4;

            if (st == 0)
              continue;
            counts[i] = st;
            break;
        }
      m1:
        points[i] = pointc;
        meass[i] = measc;
    }
}

void check_key_on()
{
    uchar  i, j;

    if (skip_point) return;
    if (rec2 == 0) return;
    if (rec3 == 0) return;
    if (cur_mode == 0) return;

    if ((key_bias[ctr] & (char)0x80) == 0)         /* bug fix 2004.7.10 */
        rec0 = (rec0 + play_bias + key_bias[ctr]) & 0x7f;

    j = 255;
    for (i = 0; i < 16; i++) {
        if (r_key[ctr][i] == rec0) {
            if (r_step[ctr][i] == 0) goto m1;
            goto m2;
        }
        if (j == 255 && r_step[ctr][i] == 0)
            j = i;
    }
    if (j == 255) return;
    i = j;
    r_key[ctr][i] = rec0;
  m1:
    midi_out(rec3 * 0x10000 + rec0 * 0x100 + 0x90 + tr_ch[ctr]);
    ons[ctr]++;
    if (velgraph[ctr] < rec3 * 2)
      velgraph[ctr] = rec3 * 2;
  m2:
    r_step[ctr][i] = rec2;
}

void check_key_off()     /*gate-1ēKXkey off*/
{
    uchar i, n, s;

    if (skip_point) return;
    i = 0;
    n = ons[ctr];
    while (n) {
        s = r_step[ctr][i];
        if (s != 0) {
            r_step[ctr][i] = s - 1;
            if (r_step[ctr][i] == 0) {
                midi_out(r_key[ctr][i] * 0x100 + 0x90 + tr_ch[ctr]);
                ons[ctr] -= 1;
            }
            n--;
        }
        i++;
    }
    if (velgraph[ctr] > 0)
      velgraph[ctr]--;
}

void usr_excl()  /* (90-97) */
{
    uchar sum = 0;
    int   sumstart = 0;
    int   i;
    uchar *p = fdata + 0x041e + (rec0 & 7) * 48;
    uchar buffer[256], a = 0;

    buffer[a++] = 0xf0;

    for (i = 0; i < 24; i++) {
        switch(p[i]) {
            case 0x80:
                buffer[a++] = rec2;
                if(sumstart == 1) sum += rec2;
                break;
            case 0x81:
                buffer[a++] = rec3;
                if(sumstart == 1) sum += rec3;
                break;
            case 0x82:
                buffer[a++] = tr_ch[ctr];
                if(sumstart == 1) sum += tr_ch[ctr];
                break;
            case 0x83:
                sumstart = 1;
                break;
            case 0x84:
                sum = (0x00 - sum) & 0x7f;
                buffer[a++] = sum;
                sumstart = 0;
                break;
            case 0xf7:
                goto m9;
            default:
                buffer[a++] = p[i];
                if(sumstart == 1) sum += p[i];
                break;
        }
    }
  m9:
    buffer[a++] = 0xf7;
    midi_out_long(buffer, a);
}

void tr_excl() /* (98) */
{
    uchar sum = 0;
    uchar value[2];
    int   sumstart = 0;
    int   j;
    uchar buffer[256], a = 0;

    pointc += 4;

    buffer[a++] = 0xf0;

    while (1) {
        if (pointc[0] != 0xf7) break;

        value[0] = pointc[2];
        value[1] = pointc[3];
        pointc += 4;

        for (j = 0; j < 2; j++) {
            switch (value[j]) {
                case 0x80:  /* gt */
                    buffer[a++] = rec2;
                    if (sumstart) sum += rec2;
                    break;
                case 0x81:  /* vel */
                    buffer[a++] = rec3;
                    if (sumstart) sum += rec3;
                    break;
                case 0x82:  /* ch */
                    buffer[a++] = tr_ch[ctr];
                    if (sumstart) sum += tr_ch[ctr];
                    break;
                case 0x83:  /* cs */
                    sumstart = 1;
                    break;
                case 0x84:  /* ss */
                    sum = (0x00 - sum) & 0x7f;
                    buffer[a++] = sum;
                    sumstart = 0;
                    break;
                case 0xf7:
                    goto m9;
                default:
                    buffer[a++] = value[j];
                    if (sumstart == 1) sum += value[j];
                    break;
            }
        }
    }
  m9:
    pointc -= 4;

    buffer[a++] = 0xf7;
    midi_out_long(buffer, a);
}

void rol_dev() /* (df) */
{
    rol_ex_data[ctr][2] = rec2;
    rol_ex_data[ctr][3] = rec3;
}

void rol_base() /* (dd) */
{
    rol_ex_data[ctr][5] = rec2;
    rol_ex_data[ctr][6] = rec3;
}

void rol_para() /* (de) */
{
    uchar sum = 0;
    int i;

    rol_ex_data[ctr][7] = rec2;
    rol_ex_data[ctr][8] = rec3;

    for (i = 5; i < 9; i++)
      sum += rol_ex_data[ctr][i];
    sum = (0x00 - sum) & 0x7f;
    rol_ex_data[ctr][9] = sum;

    midi_out_long(rol_ex_data[ctr], 11);
}

void bank_program() /* (e2) */
{
    uchar ch;

    ch = tr_ch[ctr];
    midi_out(rec3 * 0x10000 + 0x00 * 0x100 + 0xb0 + ch); /* bank */
    midi_out(0x00 * 0x10000 + 0x20 * 0x100 + 0xb0 + ch); /* bank low */
    midi_out(                 rec2 * 0x100 + 0xc0 + ch); /* program change */
}

void midi_channel() /* (e6) */
{
    uchar i, n;

    /* oZbg */
    i = 0;
    n = ons[ctr];
    while (n) {
        if (r_step[ctr][i] != 0) {
            r_step[ctr][i] = 0;
            midi_out(0 * 0x10000 + r_key[ctr][i] * 0x100 + 0x90 + tr_ch[ctr]);
        }
        n--;
        i++;
    }
    ons[ctr] = 0;

    if (rec2 != 0) {
        tr_ch[ctr] = (rec2 - 1) & 0x0f;
        /* o͋K */
        tr_mode[ctr] &= 0x17;
    }
    else {
        /* o͋K */
        tr_mode[ctr] |= 0x08;
    }
}

void ch_pressure() /* (ea) */
{
    midi_out(rec2 * 0x100 + 0xd0 + tr_ch[ctr]);
}

void key_pressure() /* (ed) */
{
    midi_out(rec3 * 0x10000 + rec2 * 0x100 + 0xa0 + tr_ch[ctr]);
}

void loop_end() /* (f8) */
{
    int i = lp_ln[ctr];

    if (i == 0) return;  /* Ήloop beginȂ */
    i--;
    lp_l3[ctr][i]++;
    if ((lp_l3[ctr][i] & 0xff) != rec1) { /* [v */
        pointc = lp_l1[ctr][i];
        lp_s[ctr] = lp_l2[ctr][i];
        measc = lp_l4[ctr][i];
    }
    else {                                /* [v */
        lp_ln[ctr] = i;
    }
}

void loop_begin() /* (f9) */
{
    int i = lp_ln[ctr];

    if (i == 5) return;             /* [ṽlXg͂T܂ */
    lp_l1[ctr][i] = pointc;
    lp_l2[ctr][i] = lp_s[ctr];
    lp_l3[ctr][i] = 0;
    lp_l4[ctr][i] = measc;
    lp_ln[ctr] = i + 1;
}

void same_meas() /* (fc) */
{
    int value1, value2, i;

    if (lp_s[ctr] != NULL) {
        measc++;
        pointc = lp_s[ctr];
        lp_s[ctr] = NULL;
        return;
    }

    if ((pointc - pointb[ctr] != 0x2c) && (pointc[-4] < 0xfc))
        measc++;

    lp_s[ctr] = pointc;
    for (i = 0; i < 10; i++) {  /* same meas->same meas̒H10܂ */
        value1 = pointc[2];
        value2 = pointc[3];
        pointc = pointb[ctr] + ((value1 & 0xfc) | (value2 << 8));
        if (pointc[0] != 0xfc) {
            pointc -= 4;
            return;
        }
    }
    pointc = lp_s[ctr];  /* H莸s */
}

void meas_end() /* (fd) */
{
    measc++;
    if (lp_s[ctr] != NULL) {
        pointc = lp_s[ctr];
        lp_s[ctr] = NULL;
    }
}
